Remove warning on shadowing block params

06/15/2016 02:44 AM - soutaro (Soutaro Matsumoto)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

Description

Running ruby with -w option reports warnings on shadowing block params.

$ cat -n w.rb

     1 a = [1]

     2 

     3 a.each do |a|

     4   a = 3

     5 end

     6 

     7 p a

$ ruby -cw w.rb

w.rb:3: warning: shadowing outer local variable - a

Syntax OK

 I would like to propose to remove the warning.

It was introduced to ruby 1.9, a version which changes behaviors on conflicts of local vars and block param. I understand it is to tell

the user the change, and let them fix if their program depends on 1.8 behavior. ruby 1.9.1 is released in 2009, almost seven years

ago, and most ruby programmers today would have correct understanding of current behavior. In my opinion, the warning does not

make sense now but just annoying.

I like giving block params shadowing name to avoid finding new good names

Lint tools including RuboCop can report the warning instead of ruby

Associated revisions

Revision 7f69d4e41f1cd77e142b786596dd005891a233f3 - 10/26/2018 02:54 AM - mame (Yusuke Endoh)

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }

Fixes [Feature #12490].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@65367 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7f69d4e41f1cd77e142b786596dd005891a233f3 - 10/26/2018 02:54 AM - mame (Yusuke Endoh)

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }

Fixes [Feature #12490].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@65367 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 7f69d4e4 - 10/26/2018 02:54 AM - mame (Yusuke Endoh)

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }
Fixes [Feature #12490].

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@65367 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c9d720b873f570c734b136eb639f0be117803f5c - 10/26/2018 03:10 AM - mame (Yusuke Endoh)

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }

 Fixes [Feature #12490].

A patch from Soutaro Matsumoto matsumoto@soutaro.com.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@65369 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c9d720b873f570c734b136eb639f0be117803f5c - 10/26/2018 03:10 AM - mame (Yusuke Endoh)

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }

 Fixes [Feature #12490].

A patch from Soutaro Matsumoto matsumoto@soutaro.com.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@65369 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision c9d720b8 - 10/26/2018 03:10 AM - mame (Yusuke Endoh)

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }

 Fixes [Feature #12490].

A patch from Soutaro Matsumoto matsumoto@soutaro.com.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@65369 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/17/2016 08:21 PM - shevegen (Robert A. Heiler)

I guess the argument given by Soutaro Matsumoto makes sense (if this was indeed the reason why the warning has been added).

On a belated note, perhaps in the path towards ruby 3.x, we may have a better/finer control into how ruby issues warnings

in general. In general I always run via -w, but not every warning appears to be hugely important to me. And I think there

is no fine-control over how to get notified about warnings (other than changing $VERBOSE and re-setting it again, but

this is a bit crude and it does not read extremely elegant in code when one assigns $VERBOSE = nil)

#2 - 08/10/2016 03:15 AM - shyouhei (Shyouhei Urabe)

We looked at this issue at yesterday's developer meeting.  While myself was positive to this, Matz is not.  He thinks that shadowing by itself is a bad

habit and should be discouraged.  You need to show him a good advantage of encouraging variable shadowing to persuade him.

#3 - 10/10/2018 08:42 AM - knu (Akinori MUSHA)

I definitely agree.  Here's a typical example that makes me mad when I get the warning:

user = users.find { |user| user.parent == parent }

 And I just don't want to change the inner variable name to something like u or user_ just to silence the warning.

#4 - 10/10/2018 08:44 AM - knu (Akinori MUSHA)

And we've got Matz's approval for this proposal!  Congratulations!

#5 - 10/26/2018 02:54 AM - mame (Yusuke Endoh)

- Status changed from Open to Closed
Applied in changeset trunk|r65367.

parse.y: remove "shadowing outer local variable" warning

You can now write the following without warning.

user = User.all.find {|user| cond(user) }

Fixes [Feature #12490].

Files

remove-shadowing-warning.patch 3.62 KB 06/15/2016 soutaro (Soutaro Matsumoto)

Powered by TCPDF (www.tcpdf.org)

06/18/2025 3/3

https://bugs.ruby-lang.org/issues/12490
http://www.tcpdf.org

